/* 
* ======  ======
*
* : Name Locker
* : Sho0ter
* : 1.2
*  : 03.02.2011
*  : http://cs.4m.net.ua
*
* ========  ========
*
*    
*     IP/STEAMID
*
* ========  =========
*
* 1.    IP
* 2.    STEAMID
* 3.   
* 4.    
* 5.    
*
* ==    ==
*
*	say /lockip
*		-    IP
*
*	say /locksteam
*		-    STEAMID
*
*	say /unlock
*		-  
*
* ==    ==
*
*	name_locker_menu
*		-   
*
* =====  ======
* 	
* nl_motd_info <0/1> [ : 1]
* 	-      
*	- 0 
*	- 1 
*
* nl_connect_info <0/1> [ : 1]
*	-     
*	- 0 
*	- 1 
*
* nl_contact <> [ : http://cs.4m.net.ua]
* 	-  
*
* nl_prune <> [ : 30]
*	-     
*	- 0 
*
* nl_host <> [ : localhost]
*	-   
*
* nl_db <> [ : ]
*	-  
*
* nl_user <> [ : root]
*	-   
*
* nl_pass <> [ : ]
*	-   
*
* ===   ===
*
* 1.2:
*	[+]   MySQL
*	[+]   
*
* 1.1:
*	[*]   
*	[+]  
*
* 1.0:
*	[!]  
*
* ============================
*/
#include <amxmodx>

//#define MYSQL

#if defined MYSQL
	#include <db>
	#define VERSION "1.2 MySQL"
#else
	#define MAX_DATA 10000
	#define VERSION "1.2 File"
#endif
#define ACCESS_LEVEL ADMIN_RCON

#if defined MYSQL
new pvhost
new pvdb
new pvuser
new pvpass
new menutemp[33][8]
new tempnames[33][8]
#else
enum data_array
{
	name[32],
	ip[32],
	steam[34],
	pass[32],
	type,
	last
}
new data[MAX_DATA][data_array]
new datafile[128]
new datanum
#endif

new blacklist[100][32]
new blacknum
new position[33]
new yn[33]
new sayt

new pvmotd
new pvconn
new pvcontact
new pvprune

public plugin_init()
{
	register_plugin("Name Locker", VERSION, "Sho0ter")
	register_dictionary("name_locker.txt")
	register_clcmd("say /lockip", "cmd_ip")
	register_clcmd("say /locksteam", "cmd_steam")
	register_clcmd("say /unlock", "cmd_unlock")
	register_clcmd("say /lockinfo", "cmd_info")
	register_clcmd("name_locker_menu", "cmd_menu")
	pvmotd = register_cvar("nl_motd_info", "1")
	pvconn = register_cvar("nl_connect_info", "1")
	pvcontact = register_cvar("nl_contact", "http://cs.4m.net.ua")
	pvprune = register_cvar("nl_prune", "30")
	register_menucmd(register_menuid("nl menu"), 1023, "nl_menu")
	register_menucmd(register_menuid("yn menu"), 1023, "yn_menu")
	register_cvar("name_locker", VERSION, FCVAR_SERVER)
	sayt = get_user_msgid("SayText")
#if defined MYSQL
	pvhost = register_cvar("nl_host", "localhost")
	pvdb = register_cvar("nl_db", "")
	pvuser = register_cvar("nl_user", "root")
	pvpass = register_cvar("nl_pass", "")
#else
	get_localinfo("amxx_datadir", datafile, charsmax(datafile))
	add(datafile, charsmax(datafile), "/names.dat")
#endif
	load_data()
	return PLUGIN_CONTINUE
}



public load_data()
{
#if defined MYSQL
	new dbhost[64], db[128], dbuser[32], dbpass[32]
	get_pcvar_string(pvhost, dbhost, charsmax(dbhost))
	get_pcvar_string(pvdb, db, charsmax(db))
	get_pcvar_string(pvuser, dbuser, charsmax(dbuser))
	get_pcvar_string(pvpass, dbpass, charsmax(dbpass))
	if(db_init(dbhost, db, dbuser, dbpass))
	{
		new text[2048], len
		len = format(text, charsmax(text), "CREATE TABLE IF NOT EXISTS `name_locker` (`player_id` int(8) unsigned NOT NULL auto_increment, `player_name` varchar(35) NOT NULL default '', `player_ip` varchar(20) NOT NULL default '', `player_steamid` varchar(25) NOT NULL default '', `player_pass` varchar(20) NOT NULL default ''")
		len += format(text[len], charsmax(text) - len, ", `player_type` int(8) unsigned NOT NULL default '0', `time` timestamp(14) NOT NULL, PRIMARY KEY (`player_id`), KEY `player_name` (`player_name`), KEY `player_ip` (`player_ip`), KEY `player_steamid` (`player_steamid`)) TYPE=MyISAM;")
		db_send(text)
		if(get_pcvar_num(pvprune))
		{
			format(text, charsmax(text), "DELETE FROM name_locker WHERE (DATE_SUB(CURDATE(), INTERVAL %d DAY) > time);", get_pcvar_num(pvprune))
			db_send(text)
		}
		db_send("DELETE FROM name_locker WHERE `player_type` = '0';")
	}
#else
	if(file_exists(datafile))
	{
		new i, len, temp[512], temptype[32], templast[32]
		new data_size = file_size(datafile, 1)
		if(data_size >= MAX_DATA)
		{
			delete_file(datafile)
			return PLUGIN_CONTINUE
		}
		while(i <= data_size && read_file(datafile, i , temp, charsmax(temp), len))
		{
			i++
			if(temp[0] == ';' || !len)
			{
				continue
			}
			parse(temp, data[datanum][name], 31, data[datanum][ip], 31, data[datanum][steam], 33, data[datanum][pass], 31, temptype, 31, templast, 31)
			data[datanum][type] = str_to_num(temptype)
			data[datanum][last] = str_to_num(templast)
			if((data[datanum][last] + (get_pcvar_num(pvprune) * 24 * 60 * 60)) < get_systime(0) && get_pcvar_num(pvprune))
			{
				continue
			}
			datanum++
		}
	}
#endif
	new blackfile[128]
	get_localinfo("amxx_configsdir", blackfile, charsmax(blackfile))
	add(blackfile, charsmax(blackfile), "/blackfile.ini")
	if(file_exists(blackfile))
	{
		new i, len
		while(blacknum < 100 && read_file(blackfile, i, blacklist[blacknum], 31, len))
		{
			if(!len || blacklist[blacknum][0] == ';')
			{
				continue
			}
			blacknum++
		}
	}
	return PLUGIN_CONTINUE
}

public client_putinserver(id)
{
	if(get_pcvar_num(pvconn))
	{
		set_task(15.0, "show_info", id + 118811)
	}
	return PLUGIN_HANDLED
}

public show_info(id)
{
	id -= 118811
	if(is_user_connected(id))
	{
		color_print(id, "%L !g/lockinfo", id, "NL_CONN_INF")
	}
	return PLUGIN_HANDLED
}

public client_authorized(id)
{
	new lock = get_locked(id, 1)
	if(lock == -1)
	{
			server_cmd("kick #%d  %L", get_user_userid(id), id, "NL_KICK1")
	}
	else if(lock >= 0)
	{
#if defined MYSQL
		new text[512]
		format(text, charsmax(text), "UPDATE `name_locker` SET time = NOW() WHERE (`player_id` = '%d');", lock)
		db_thread(text)
#else
		data[lock][last] = get_systime(0)
#endif
	}
	return PLUGIN_CONTINUE
}

public client_infochanged(id)
{
	new newname[32], oldname[32]
	get_user_name(id, oldname, charsmax(oldname))
	get_user_info(id, "name", newname, charsmax(newname))
	if(!equal(oldname, newname) && is_user_connected(id))
	{
		if(get_locked(id, 2) == -1)
		{
			server_cmd("kick #%d  %L", get_user_userid(id), id, "NL_KICK2")
		}
	}
	return PLUGIN_CONTINUE
}

public cmd_menu(id)
{
	if(!(get_user_flags(id) & ACCESS_LEVEL))
	{
		client_print(id, print_notify, "No access")
		return PLUGIN_HANDLED
	}
	show_nl_menu(id, position[id] = 0)
	return PLUGIN_HANDLED
}

public show_nl_menu(id, pos)
{
	if(pos < 0)
	{
		return PLUGIN_HANDLED
	}
	new body[1024], keys, len, key
	new start = pos * 8
	new end = start + 8
#if defined MYSQL
	if(!db_is_avalible())
	{
		return PLUGIN_HANDLED
	}
	new text[512]
	format(text, charsmax(text), "SELECT * FROM `name_locker`")
	new Handle:query = SQL_PrepareQuery(dbconnect, text)
	if(!SQL_Execute(query))
	{
		return db_error(query, text)
	}
	new rows = SQL_NumResults(query)
	len = format(body, charsmax(body), "\y%L^n^n\d%L: %d-%d %L %d^n%L: %d %L %d^n^n", id, "NL_MENU_TITLE1", id, "NL_VWD", start + 1, (end < rows) ? end : rows, id, "NL_OF", rows, id, "NL_PG", pos + 1, id, "NL_OF", floatround(float(rows) / 8.0, floatround_ceil))
	format(text, charsmax(text), "SELECT `player_id`, `player_name`, `player_ip`, `player_steamid`, `player_pass`, `player_type` FROM `name_locker` LIMIT %d , %d;", start, end)
	query = SQL_PrepareQuery(dbconnect, text)
	if(!SQL_Execute(query))
	{
		return db_error(query, text)
	}
	while(SQL_MoreResults(query))
	{
		new ip[32], steam[34], pass[32], type
		menutemp[id][key] = SQL_ReadResult(query, 0)
		SQL_ReadResult(query, 1, tempnames[id][key], 31)
		SQL_ReadResult(query, 2, ip, charsmax(ip))
		SQL_ReadResult(query, 3, steam, charsmax(steam))
		SQL_ReadResult(query, 4, pass, charsmax(pass))
		type = SQL_ReadResult(query, 5)
		if(type)
		{
			keys |= (1<<key)
			if(type == 1)
			{
				len += format(body[len], charsmax(body) - len, "\r%d. \w%s \dIP: \y%s \dPWD: \y%s^n", ++key, tempnames[id][key], ip, pass)
			}
			else
			{
				len += format(body[len], charsmax(body) - len, "\r%d. \w%s \dSTEAMID: \y%s \dPWD: \y%s^n", ++key, tempnames[id][key], steam, pass)
			}
		}
		else
		{
			len += format(body[len], charsmax(body) - len, "\r%d. \d%s \r%L^n", ++key, tempnames[id][key-1], id, "NL_MENU_DELETED")
		}
		SQL_NextRow(query)
		
	}
	SQL_FreeHandle(query)
	if(end < (rows - 1))
	{
		keys |= (1<<8)
		len += format(body[len], charsmax(body) - len, "^n\r9. \w%L^n", id, "NL_MENU_MORE")
	}
	else
	{
		len += format(body[len], charsmax(body) - len, "^n\r9. \d%L^n", id, "NL_MENU_MORE")
	}
#else
	len = format(body, charsmax(body), "\y%L^n^n\d%L: %d-%d %L %d^n%L: %d %L %d^n^n", id, "NL_MENU_TITLE1", id, "NL_VWD", start + 1, (end < datanum) ? end : datanum, id, "NL_OF", datanum, id, "NL_PG", pos + 1, id, "NL_OF", floatround(float(datanum) / 8.0, floatround_ceil))
	for(new i = start; i < end; i++)
	{
		if(i < datanum)
		{
			if(data[i][type])
			{
				keys |= (1<<key)
				if(data[i][type] == 1)
				{
					len += format(body[len], charsmax(body) - len, "\r%d. \w%s \dIP: \y%s \dPWD: \y%s^n", ++key, data[i][name], data[i][ip], data[i][pass])
				}
				else
				{
					len += format(body[len], charsmax(body) - len, "\r%d. \w%s \dSTEAMID: \y%s \dPWD: \y%s^n", ++key, data[i][name], data[i][steam], data[i][pass])
				}
			}
			else
			{
				len += format(body[len], charsmax(body) - len, "\r%d. \d%s \r%L^n", ++key, data[i][name], id, "NL_MENU_DELETED")
			}
		}
		else
		{
			len += format(body[len], charsmax(body) - len, "^n")
		}
	}
	if(end < (datanum - 1))
	{
		keys |= (1<<8)
		len += format(body[len], charsmax(body) - len, "^n\r9. \w%L^n", id, "NL_MENU_MORE")
	}
	else
	{
		len += format(body[len], charsmax(body) - len, "^n\r9. \d%L^n", id, "NL_MENU_MORE")
	}
#endif
	keys |= MENU_KEY_0
	len += format(body[len], charsmax(body) - len, "\r0. \w%L^n^n\yName Locker v%s by Sho0ter", id, pos ? "NL_MENU_BACK" : "NL_MENU_EXIT", VERSION)
	show_menu(id, keys, body, -1, "nl menu")
	return PLUGIN_HANDLED
}

public nl_menu(id, key)
{
	switch(key)
	{
		case 8: show_nl_menu(id, ++position[id])
		case 9: show_nl_menu(id, --position[id])
		default:
		{
#if defined MYSQL
			yn[id] = key
#else
			yn[id]= (position[id] * 8) + key
#endif
			show_yn_menu(id)
		}
	}
	return PLUGIN_HANDLED
}

public show_yn_menu(id)
{
	new body[1024]
#if defined MYSQL
	format(body, charsmax(body), "\y%L \r%s\y.^n%L?^n^n\r1. \w%L^n\r2. \w%L^n^n\yName Locker v%s by Sho0ter", id, "NL_MENU_TITLE1_1", tempnames[id][yn[id]], id, "NL_MENU_TITLE1_2", id, "NL_MENU_YES", id, "NL_MENU_NO", VERSION)
#else
	format(body, charsmax(body), "\y%L \r%s\y.^n%L?^n^n\r1. \w%L^n\r2. \w%L^n^n\yName Locker v%s by Sho0ter", id, "NL_MENU_TITLE1_1", data[yn[id]][name], id, "NL_MENU_TITLE1_2", id, "NL_MENU_YES", id, "NL_MENU_NO", VERSION)
#endif
	show_menu(id, (1<<0)|(1<<1), body, -1, "yn menu")
	return PLUGIN_HANDLED
}

public yn_menu(id, key)
{
	if(!key)
	{
#if defined MYSQL
		new text[512]
		format(text, charsmax(text), "REPLACE INTO `name_locker` (`player_id` , `player_type`) VALUES ( '%d', '0');", menutemp[id][yn[id]])
		db_send(text)
#else
		data[yn[id]][type] = 0
#endif
	}
	show_nl_menu(id, position[id])
	return PLUGIN_HANDLED
}

public cmd_ip(id)
{
	if(is_black_list(id))
	{
		new lnk[32]
		get_pcvar_string(pvcontact, lnk, charsmax(lnk))
		color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
		return PLUGIN_HANDLED
	}
	new locked = get_locked(id, 1)
	new free1 = get_free_lock(id, 1)
	new free2 = get_free_lock(id, 2)
#if defined MYSQL
	if(!db_is_avalible())
	{
		new lnk[32]
		get_pcvar_string(pvcontact, lnk, charsmax(lnk))
		color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
		return PLUGIN_HANDLED
	}
	new text[512]
	if(locked >= 0)
	{
		format(text, charsmax(text), "SELECT `player_ip`, `player_steamid`, `player_type` FROM `name_locker` WHERE (`player_id` = '%d');", locked)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		if(!SQL_NumResults(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			SQL_FreeHandle(query)
			return PLUGIN_HANDLED
		}
		new ip[32], steam[34], type
		SQL_ReadResult(query, 0, ip, charsmax(ip))
		SQL_ReadResult(query, 1, steam, charsmax(steam))
		type = SQL_ReadResult(query, 2)
		SQL_FreeHandle(query)
		if(type == 1)
		{
			color_print(id, "%L !gIP !t%s", id, "NL_ALREADY_YOUR", ip)
			color_print(id, "%L !gIP!y %L !t/unlock", id, "NL_UNLOCK_INF1", id, "NL_TYPE")
			return PLUGIN_HANDLED
		}
		else if(type == 2)
		{
			color_print(id, "%L !gSTEAMID !t%s", id, "NL_ALREADY_YOUR", steam)
			color_print(id, "%L !gSTEAMID!y %L !t/unlock", id, "NL_UNLOCK_INF1", id, "NL_TYPE")
			return PLUGIN_HANDLED
		}
	}
	else if(free1 != -1)
	{
		format(text, charsmax(text), "SELECT `player_name`, `player_ip` FROM `name_locker` WHERE (`player_id` = '%d') AND (`player_type` = '1');", free1)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		if(!SQL_NumResults(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			SQL_FreeHandle(query)
			return PLUGIN_HANDLED
		}
		new name[32], ip[32]
		SQL_ReadResult(query, 0, name, charsmax(name))
		SQL_ReadResult(query, 1, ip, charsmax(ip))
		SQL_FreeHandle(query)
		color_print(id, "%L !gIP !t%s!y %L !t%s!y", id, "NL_TO_YOUR", ip, id, "NL_ALREADY_NICK", name)
		color_print(id, "%L !t/unlock!y", id, "NL_FOR_UN")
		return PLUGIN_HANDLED
	}
	else if(free2 != -1)
	{
		format(text, charsmax(text), "SELECT `player_name`, `player_steamid` FROM `name_locker` WHERE (`player_id` = '%d') AND (`player_type` = '2');", free2)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		if(!SQL_NumResults(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			SQL_FreeHandle(query)
			return PLUGIN_HANDLED
		}
		new name[32], steam[32]
		SQL_ReadResult(query, 0, name, charsmax(name))
		SQL_ReadResult(query, 1, steam, charsmax(steam))
		SQL_FreeHandle(query)
		color_print(id, "%L !gSTEAMID !t%s!y %L !t%s!y", id, "NL_TO_YOUR", steam, id, "NL_ALREADY_NICK", name)
		color_print(id, "%L !t/unlock!y", id, "NL_FOR_UN")
		return PLUGIN_HANDLED
	}
	else
	{
		new name[32], ip[32], steam[32], pass[32]
		get_user_name(id, name, 31)
		get_user_ip(id, ip, 31, 1)
		get_user_authid(id, steam, 31)
		format(pass, 31, "%c%d%c%d%c%d", random_num('a', 'z'), random_num(0, 9), random_num('a', 'z'), random_num(0, 9), random_num('a', 'z'), random_num(0, 9))
		client_cmd(id, "setinfo ^"_nl^" ^"%s^";echo Your password: %s", pass, pass)
		format(text, charsmax(text), "INSERT INTO `name_locker` (`player_id` , `player_name`, `player_ip` , `player_steamid`, `player_pass`, `player_type`, `time`) VALUES (NULL, '%s', '%s', '%s', '%s', '1', NOW())", name, ip, steam, pass)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		color_print(id, "%L !gIP !t%s", id, "NL_SUCC", ip)
		color_print(id, "%L !t/unlock", id, "NL_SUCC_UN")
		color_print(id, "%L !g%s!t, %L", id, "NL_SUCC_PASS", pass, id, "NL_SUCC_REM")
		show_succ_motd(id, SQL_GetInsertId(query))
		SQL_FreeHandle(query)
		set_task(1.0, "screen_user", id + 114411)
	}
#else
	if(locked >= 0 && data[locked][type] == 1)
	{
		color_print(id, "%L !gIP !t%s", id, "NL_ALREADY_YOUR", data[locked][ip])
		color_print(id, "%L !gIP!y %L !t/unlock", id, "NL_UNLOCK_INF1", id, "NL_TYPE")
		return PLUGIN_HANDLED
	}
	else if(locked >= 0 && data[locked][type] == 2)
	{
		color_print(id, "%L !gSTEAMID !t%s", id, "NL_ALREADY_YOUR", data[locked][steam])
		color_print(id, "%L !gSTEAMID!y %L !t/unlock", id, "NL_UNLOCK_INF1", id, "NL_TYPE")
		return PLUGIN_HANDLED
	}
	
	else if(free1 != -1)
	{
		color_print(id, "%L !gIP !t%s!y %L !t%s!y", id, "NL_TO_YOUR", data[free1][ip], id, "NL_ALREADY_NICK", data[free1][name])
		color_print(id, "%L !t/unlock!y", id, "NL_FOR_UN")
		return PLUGIN_HANDLED
	}
	else if(free2 != -1)
	{
		color_print(id, "%L !gSTEAMID !t%s!y %L !t%s!y", id, "NL_TO_YOUR", data[free2][steam], id, "NL_ALREADY_NICK", data[free2][name])
		color_print(id, "%L !t/unlock!y", id, "NL_FOR_UN")
		return PLUGIN_HANDLED
	}
	else
	{
		get_user_name(id, data[datanum][name], 31)
		get_user_ip(id, data[datanum][ip], 31, 1)
		get_user_authid(id, data[datanum][steam], 31)
		format(data[datanum][pass], 31, "%c%d%c%d%c%d", random_num('a', 'z'), random_num(0, 9), random_num('a', 'z'), random_num(0, 9), random_num('a', 'z'), random_num(0, 9))
		data[datanum][last] = get_systime(0)
		client_cmd(id, "setinfo ^"_nl^" ^"%s^";echo Your password: %s", data[datanum][pass], data[datanum][pass])
		data[datanum][type] = 1
		color_print(id, "%L !gIP !t%s", id, "NL_SUCC", data[datanum][ip])
		color_print(id, "%L !t/unlock", id, "NL_SUCC_UN")
		color_print(id, "%L !g%s!t, %L", id, "NL_SUCC_PASS", data[datanum][pass], id, "NL_SUCC_REM")
		show_succ_motd(id, datanum)
		set_task(1.0, "screen_user", id + 114411)
		datanum++
	}
#endif
	return PLUGIN_CONTINUE
}

public cmd_steam(id)
{	
	new locked = get_locked(id, 1)
	new free1 = get_free_lock(id, 1)
	new free2 = get_free_lock(id, 2)
#if defined MYSQL
	if(!db_is_avalible())
	{
		return PLUGIN_HANDLED
	}
	new text[512]
	if(locked >= 0)
	{
		format(text, charsmax(text), "SELECT `player_ip`, `player_steamid`, `player_type` FROM `name_locker` WHERE (`player_id` = '%d');", locked)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		if(!SQL_NumResults(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			SQL_FreeHandle(query)
			return PLUGIN_HANDLED
		}
		new ip[32], steam[34], type
		SQL_ReadResult(query, 0, ip, charsmax(ip))
		SQL_ReadResult(query, 1, steam, charsmax(steam))
		type = SQL_ReadResult(query, 2)
		SQL_FreeHandle(query)
		if(type == 1)
		{
			color_print(id, "%L !gIP !t%s", id, "NL_ALREADY_YOUR", ip)
			color_print(id, "%L !gIP!y %L !t/unlock", id, "NL_UNLOCK_INF1", id, "NL_TYPE")
			return PLUGIN_HANDLED
		}
		else if(type == 2)
		{
			color_print(id, "%L !gSTEAMID !t%s", id, "NL_ALREADY_YOUR", steam)
			color_print(id, "%L !gSTEAMID!y %L !t/unlock", id, "NL_UNLOCK_INF1", id, "NL_TYPE")
			return PLUGIN_HANDLED
		}
	}
	else if(free1 != -1)
	{
		format(text, charsmax(text), "SELECT `player_name`, `player_ip` FROM `name_locker` WHERE (`player_id` = '%d') AND (`player_type` = '1');", free1)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		if(!SQL_NumResults(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			SQL_FreeHandle(query)
			return PLUGIN_HANDLED
		}
		new name[32], ip[32]
		SQL_ReadResult(query, 0, name, charsmax(name))
		SQL_ReadResult(query, 1, ip, charsmax(ip))
		SQL_FreeHandle(query)
		color_print(id, "%L !gIP !t%s!y %L !t%s!y", id, "NL_TO_YOUR", ip, id, "NL_ALREADY_NICK", name)
		color_print(id, "%L !t/unlock!y", id, "NL_FOR_UN")
		return PLUGIN_HANDLED
	}
	else if(free2 != -1)
	{
		format(text, charsmax(text), "SELECT `player_name`, `player_steamid` FROM `name_locker` WHERE (`player_id` = '%d') AND (`player_type` = '2');", free2)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		if(!SQL_NumResults(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			SQL_FreeHandle(query)
			return PLUGIN_HANDLED
		}
		new name[32], steam[32]
		SQL_ReadResult(query, 0, name, charsmax(name))
		SQL_ReadResult(query, 1, steam, charsmax(steam))
		SQL_FreeHandle(query)
		color_print(id, "%L !gSTEAMID !t%s!y %L !t%s!y", id, "NL_TO_YOUR", steam, id, "NL_ALREADY_NICK", name)
		color_print(id, "%L !t/unlock!y", id, "NL_FOR_UN")
		return PLUGIN_HANDLED
	}
	else
	{
		new name[32], ip[32], steam[32], pass[32]
		get_user_name(id, name, 31)
		get_user_ip(id, ip, 31, 1)
		get_user_authid(id, steam, 31)
		format(pass, 31, "%c%d%c%d%c%d", random_num('a', 'z'), random_num(0, 9), random_num('a', 'z'), random_num(0, 9), random_num('a', 'z'), random_num(0, 9))
		client_cmd(id, "setinfo ^"_nl^" ^"%s^";echo Your password: %s", pass, pass)
		format(text, charsmax(text), "INSERT INTO `name_locker` (`player_id` , `player_name`, `player_ip` , `player_steamid`, `player_pass`, `player_type`, `time`) VALUES (NULL, '%s', '%s', '%s', '%s', '2', NOW())", name, ip, steam, pass)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		color_print(id, "%L !gSTEAMID !t%s", id, "NL_SUCC", steam)
		color_print(id, "%L !t/unlock", id, "NL_SUCC_UN")
		color_print(id, "%L !g%s!t, %L", id, "NL_SUCC_PASS", pass, id, "NL_SUCC_REM")
		show_succ_motd(id, SQL_GetInsertId(query))
		SQL_FreeHandle(query)
		set_task(1.0, "screen_user", id + 114411)
	}
#else
	if(locked >= 0 && data[locked][type] == 1)
	{
		color_print(id, "%L !gIP !t%s", id, "NL_ALREADY_YOUR", data[locked][ip])
		color_print(id, "%L !gIP!y %L !t/unlock", id, "NL_UNLOCK_INF1", id, "NL_TYPE")
		return PLUGIN_HANDLED
	}
	else if(locked >= 0 && data[locked][type] == 2)
	{
		color_print(id, "%L !gSTEAMID !t%s", id, "NL_ALREADY_YOUR", data[locked][steam])
		color_print(id, "%L !gSTEAMID!y %L !t/unlock", id, "NL_UNLOCK_INF1", id, "NL_TYPE")
		return PLUGIN_HANDLED
	}
	
	else if(free1 != -1)
	{
		color_print(id, "%L !gIP !t%s!y %L !t%s!y", id, "NL_TO_YOUR", data[free1][ip], id, "NL_ALREADY_NICK", data[free1][name])
		color_print(id, "%L !t/unlock!y", id, "NL_FOR_UN")
		return PLUGIN_HANDLED
	}
	else if(free2 != -1)
	{
		color_print(id, "%L !gSTEAMID !t%s!y %L !t%s!y", id, "NL_TO_YOUR", data[free2][steam], id, "NL_ALREADY_NICK", data[free2][name])
		color_print(id, "%L !t/unlock!y", id, "NL_FOR_UN")
		return PLUGIN_HANDLED
	}
	else
	{
		get_user_name(id, data[datanum][name], 31)
		get_user_ip(id, data[datanum][ip], 31, 1)
		get_user_authid(id, data[datanum][steam], 31)
		format(data[datanum][pass], 31, "%c%d%c%d%c%d", random_num('a', 'z'), random_num(0, 9), random_num('a', 'z'), random_num(0, 9), random_num('a', 'z'), random_num(0, 9))
		data[datanum][last] = get_systime(0)
		client_cmd(id, "setinfo ^"_nl^" ^"%s^";echo Your password: %s", data[datanum][pass], data[datanum][pass])
		data[datanum][type] = 2
		color_print(id, "%L !gSTEAMID !t%s", id, "NL_SUCC", data[datanum][steam])
		color_print(id, "%L !t/unlock", id, "NL_SUCC_UN")
		color_print(id, "%L !g%s!t, %L", id, "NL_SUCC_PASS", data[datanum][pass], id, "NL_SUCC_REM")
		show_succ_motd(id, datanum)
		set_task(1.0, "screen_user", id + 114411)
		datanum++
	}
#endif
	return PLUGIN_CONTINUE
}

public screen_user(id)
{
	id -= 114411
	client_cmd(id, "snapshot")
	return PLUGIN_CONTINUE
}

public show_succ_motd(id, pos)
{
	if(!get_pcvar_num(pvmotd))
	{
		return PLUGIN_HANDLED
	}
	new body[2048], len
	len = format(body, charsmax(body), "<html><head><style type=text/css>body {font-family:Verdana,Tahoma}</style>")
	len += format(body[len], charsmax(body) - len, "<meta http-equiv=Content-Type content=text/html charset=UTF-8></head>")
	len += format(body[len], charsmax(body) - len, "<body bgcolor=black><font size=3 color=green></br><b><center>%L</center></b></font><br/>", id, "NL_SUCC_MOTD1")
	len += format(body[len], charsmax(body) - len, "<font size=2 color=#c0c0ff>")
#if defined MYSQL
	if(!db_is_avalible())
	{
		return PLUGIN_HANDLED
	}
	new text[512]
	formatex(text, charsmax(text), "SELECT `player_name`, `player_ip` , `player_steamid`, `player_pass`, `player_type` FROM `name_locker` WHERE (`player_id` = '%d')", pos)
	new Handle:query = SQL_PrepareQuery(dbconnect, text)
	if(!SQL_Execute(query))
	{
		return db_error(query, text)
	}
	if(!SQL_NumResults(query))
	{
		SQL_FreeHandle(query)
		return PLUGIN_HANDLED
	}
	new name[32], ip[32], steamid[34], pass[32], type
	SQL_ReadResult(query, 0, name, charsmax(name))
	SQL_ReadResult(query, 1, ip, charsmax(ip))
	SQL_ReadResult(query, 2, steamid, charsmax(steamid))
	SQL_ReadResult(query, 3, pass, charsmax(pass))
	type = SQL_ReadResult(query, 4)
	SQL_FreeHandle(query)
	if(type == 1)
	{
		len += format(body[len], charsmax(body) - len, "%L <font color=%s>%s</font> %L <font color=yellow>IP</font> <font color=#00aaff>(%s)</font>!<br/>", id, "NL_SUCC_MOTD2", (get_user_team(id) == 1) ? "red" : "blue", name, id, "NL_SUCC_MOTD3", ip)
	}
	else
	{
		len += format(body[len], charsmax(body) - len, "%L <font color=%s>%s</font> %L <font color=yellow>STEAMID</font> <font color=#00aaff>(%s)</font><br/>", id, "NL_SUCC_MOTD2", (get_user_team(id) == 1) ? "red" : "blue", name, id, "NL_SUCC_MOTD3", steamid)
	}
	len += format(body[len], charsmax(body) - len, "%L <font color=yellow>%s</font> <font color=red>(%L)</font><br/>", id, "NL_SUCC_MOTD4", pass, id, "NL_SUCC_MOTD5")
#else
	if(data[pos][type] == 1)
	{
		len += format(body[len], charsmax(body) - len, "%L <font color=%s>%s</font> %L <font color=yellow>IP</font> <font color=#00aaff>(%s)</font>!<br/>", id, "NL_SUCC_MOTD2", (get_user_team(id) == 1) ? "red" : "blue", data[pos][name], id, "NL_SUCC_MOTD3", data[pos][ip])
	}
	else
	{
		len += format(body[len], charsmax(body) - len, "%L <font color=%s>%s</font> %L <font color=yellow>STEAMID</font> <font color=#00aaff>(%s)</font><br/>", id, "NL_SUCC_MOTD2", (get_user_team(id) == 1) ? "red" : "blue", data[pos][name], id, "NL_SUCC_MOTD3", data[pos][steam])
	}
	len += format(body[len], charsmax(body) - len, "%L <font color=yellow>%s</font> <font color=red>(%L)</font><br/>", id, "NL_SUCC_MOTD4", data[pos][pass], id, "NL_SUCC_MOTD5")
#endif
	len += format(body[len], charsmax(body) - len, "%L <font color=yellow>IP/STEAMID</font> %L", id, "NL_SUCC_MOTD6", id, "NL_SUCC_MOTD7")
	len += format(body[len], charsmax(body) - len, "<ul><li type=square>%L <font color=#00ff00>(~)</font></li>", id, "NL_SUCC_MOTD8")
#if defined MYSQL
	len += format(body[len], charsmax(body) - len, "<li type=square>%L <font color=yellow>setinfo ^"_nl^" ^"%s^"</font> %L <font color=#00aaff>ENTER</font></li>", id, "NL_SUCC_MOTD9", pass, id, "NL_SUCC_MOTD10")
#else
	len += format(body[len], charsmax(body) - len, "<li type=square>%L <font color=yellow>setinfo ^"_nl^" ^"%s^"</font> %L <font color=#00aaff>ENTER</font></li>", id, "NL_SUCC_MOTD9", data[pos][pass], id, "NL_SUCC_MOTD10")
#endif
	len += format(body[len], charsmax(body) - len, "<li type=square>%L <font color=#00aaff>/unlock</font></li>", id, "NL_SUCC_MOTD11")
	new lnk[64]
	get_pcvar_string(pvcontact, lnk, charsmax(lnk))
	len += format(body[len], charsmax(body) - len, "<li type=square>%L <font color=yellow>%s</font></li></ul><br/>", id, "NL_SUCC_MOTD14", lnk)
	len += format(body[len], charsmax(body) - len, "<center><font color=white size=1>Name Locker v%s by Sho0ter</font></center></body></html>", VERSION)
	show_motd(id, body, "Name Locker")
	
	return PLUGIN_HANDLED
}

public cmd_info(id)
{
	new body[2048], len
	len = format(body, charsmax(body), "<html><head><style type=text/css>body {font-family:Verdana,Tahoma}</style>")
	len += format(body[len], charsmax(body) - len, "<meta http-equiv=Content-Type content=text/html charset=UTF-8></head>")
	len += format(body[len], charsmax(body) - len, "<body bgcolor=black><font size=3 color=green></br><b><center>%L<font color=red>*</font></center></b></font><br/>", id, "NL_INFO_MOTD1")
	len += format(body[len], charsmax(body) - len, "<font size=2 color=#c0c0ff>")
	new cname[32]
	get_user_name(id, cname, charsmax(cname))
	len += format(body[len], charsmax(body) - len, "%L <font color=%s>%s</font> %L <font color=yellow>IP/STEAMID</font><font color=red>**</font>, %L.<br/>",id, "NL_INFO_MOTD2", (get_user_team(id) == 1) ? "red" : "blue", cname, id, "NL_INFO_MOTD3", id, "NL_INFO_MOTD4")
	len += format(body[len], charsmax(body) - len, "%L <font color=yellow>%L</font> %L:", id, "NL_INFO_MOTD5", id, "NL_INFO_MOTD6", id, "NL_INFO_MOTD7")
	new cip[32]
	get_user_ip(id, cip, charsmax(cip), 1)
	len += format(body[len], charsmax(body) - len, "<ul><li type=square><font color=#00ff00>/lockip</font> - %L <font color=yellow>IP</font> <font color=#00aaff>(%s)</font></li>", id, "NL_INFO_MOTD8", cip)
	new csteam[34]
	get_user_authid(id, csteam, charsmax(csteam))
	len += format(body[len], charsmax(body) - len, "<li type=square><font color=#00ff00>/locksteam</font> - %L <font color=yellow>STEAMID</font> <font color=#00aaff>(%s)</font></li>", id, "NL_INFO_MOTD8", csteam)
	new clock[128]
#if !defined MYSQL
	new cpos = get_locked(id, 1)
	if(cpos >= 0)
	{
		formatex(clock, charsmax(clock), "<font color=green>%s %s</font>", (data[cpos][type] == 1) ? "IP" : "STEAMID", (data[cpos][type] == 1) ? cip : csteam)
	}
	else
	{
		formatex(clock, charsmax(clock), "<font color=yellow>%L</font>", id, "NL_INFO_MOTD9")
	}
#endif
	len += format(body[len], charsmax(body) - len, "<li type=square><font color=#00ff00>/unlock</font> - %L %s</li></ul>", id, "NL_INFO_MOTD10", clock)
	new lnk[64]
	get_pcvar_string(pvcontact, lnk, charsmax(lnk))
	len += format(body[len], charsmax(body) - len, "<font color=red>*</font> %L: <font color=yellow>%s</font><br/>", id, "NL_INFO_MOTD11", lnk)
	len += format(body[len], charsmax(body) - len, "<font color=red>**</font> %L <font color=yellow>IP/STEAMID</font> <font color=red>%L</font> %L<br/><br/>", id, "NL_INFO_MOTD12", id, "NL_INFO_MOTD13", id, "NL_INFO_MOTD14")
	len += format(body[len], charsmax(body) - len, "<center><font color=white size=1>Name Locker v%s by Sho0ter</font></center></body></html>", VERSION)
	show_motd(id, body, "Name Locker")
	return PLUGIN_CONTINUE
}

public cmd_unlock(id)
{
	if(get_locked(id, 1) == -2)
	{
		color_print(id, "%L", id, "NL_NOT_LOCKED")
		return PLUGIN_HANDLED
	}
	else if(get_locked(id, 1) >= 0)
	{
		new lock = get_locked(id, 1)
#if defined MYSQL
		new text[512]
		format(text, charsmax(text), "SELECT `player_type` FROM `name_locker` WHERE (`player_id` = '%d')", lock)
		new Handle:query = SQL_PrepareQuery(dbconnect, text)
		if(!SQL_Execute(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			return db_error(query, text)
		}
		if(!SQL_NumResults(query))
		{
			new lnk[32]
			get_pcvar_string(pvcontact, lnk, charsmax(lnk))
			color_print(id, "%L: !g%s", id, "NL_ERRDB", lnk)
			SQL_FreeHandle(query)
			return PLUGIN_HANDLED
		}
		new type = SQL_ReadResult(query, 0)
		SQL_FreeHandle(query)
		new ip[32], steam[34]
		get_user_ip(id, ip, charsmax(ip), 1)
		get_user_authid(id, steam, charsmax(steam))
		if(type == 1)
		{
			format(text, charsmax(text), "REPLACE INTO `name_locker` (`player_id` , `player_type`) VALUES ( '%d', '0');", lock)
			if(!db_send(text))
			{
				return PLUGIN_HANDLED
			}
			color_print(id, "%L !gIP !t%s", id, "NL_NAME_UNLOCKED", ip)
		}
		else if(type == 2)
		{
			format(text, charsmax(text), "REPLACE INTO `name_locker` (`player_id` , `player_type`) VALUES ( '%d', '0');", lock)
			if(!db_send(text))
			{
				return PLUGIN_HANDLED
			}
			color_print(id, "%L !gSTEAMID !t%s", id, "NL_NAME_UNLOCKED", steam)
		}
#else
		if(data[lock][type] == 1)
		{
			data[lock][type] = 0
			color_print(id, "%L !gIP !t%s", id, "NL_NAME_UNLOCKED", data[lock][ip])
		}
		else if(data[lock][type] == 2)
		{
			data[lock][type] = 0
			color_print(id, "%L !gSTEAMID !t%s", id, "NL_NAME_UNLOCKED", data[lock][steam])
		}
#endif
	}
	return PLUGIN_CONTINUE
}		

public plugin_end()
{
#if defined MYSQL
	db_close()
#else
	if(file_exists(datafile))
	{
		delete_file(datafile)
	}
	for(new i; i < datanum; i++)
	{
		if(data[i][type] == 0)
		{
			continue
		}
		new line[512]
		formatex(line, charsmax(line), "^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%d^" ^"%d^"", data[i][name], data[i][ip], data[i][steam], data[i][pass], data[i][type], data[i][last])
		write_file(datafile, line)
	}
#endif
	return PLUGIN_CONTINUE		
}

stock get_locked(id, stype)
{
	new sname[32], sip[32], ssteam[34], spass[32]
	if(stype == 1)
	{
		get_user_name(id, sname, charsmax(sname))
	}
	else
	{
		get_user_info(id, "name", sname, charsmax(sname))
	}
	get_user_ip(id, sip, charsmax(sip), 1)
	get_user_authid(id, ssteam, charsmax(ssteam))
	get_user_info(id, "_nl", spass, charsmax(spass))
#if defined MYSQL
	if(!db_is_avalible())
	{
		return -2
	}
	new text[512]
	format(text, charsmax(text), "SELECT `player_id` FROM `name_locker` WHERE (`player_name` = '%s');", sname)
	new Handle:query = SQL_PrepareQuery(dbconnect, text)
	if(!SQL_Execute(query))
	{
		db_error(query, text)
		return - 2
	}
	if(!SQL_NumResults(query))
	{
		SQL_FreeHandle(query)
		return -2
	}
	new pid = SQL_ReadResult(query, 0)
	SQL_FreeHandle(query)
	format(text, charsmax(text), "SELECT `player_ip`, `player_steamid`, `player_pass`, `player_pass` FROM `name_locker` WHERE (`player_id` = '%d');", pid)
	query = SQL_PrepareQuery(dbconnect, text)
	if(!SQL_Execute(query))
	{
		db_error(query, text)
		return - 2
	}
	new tempip[32], tempsteam[34], temppass[32], temptype
	SQL_ReadResult(query, 0, tempip, charsmax(tempip))
	SQL_ReadResult(query, 1, tempsteam, charsmax(tempsteam))
	SQL_ReadResult(query, 2, temppass, charsmax(temppass))
	temptype = SQL_ReadResult(query, 3)
	if((equal(tempip, sip) && temptype == 1) || (equal(tempsteam, ssteam) && temptype == 2) || equal(temppass, spass))
	{
			return pid
	}
	else
	{
			return -1
	}
	SQL_FreeHandle(query)
#else
	for(new i; i < datanum; i++)
	{
		if(!equal(data[i][name], sname))
		{
			continue
		}
		switch(data[i][type])
		{
			case 1:
			{
				if(equal(data[i][ip], sip) || equal(data[i][pass], spass))
				{
					return i
				}
				else
				{
					return -1
				}
			}
			case 2:
			{
				if(equal(data[i][steam], ssteam) || equal(data[i][pass], spass))
				{
					return i
				}
				else
				{
					return -1
				}
			}
		}
	}
#endif
	return -2
}

stock get_free_lock(id, stype)
{
#if defined MYSQL
	new srch[34]
	if(stype == 1)
	{
		get_user_ip(id, srch, charsmax(srch), 1)
	}
	else
	{
		get_user_authid(id, srch, charsmax(srch))
	}
	new text[512]
	format(text, charsmax(text), "SELECT `player_id` FROM `name_locker` WHERE (`%s` = '%s') AND (`player_type` = '%d');", (stype == 1) ? "player_ip" : "player_steamid", srch, stype)
	new Handle:query = SQL_PrepareQuery(dbconnect, text)
	if(!SQL_Execute(query))
	{
		db_error(query, text)
		return -2
	}
	if(!SQL_NumResults(query))
	{
		SQL_FreeHandle(query)
		return -1
	}
	else
	{
		new temp = SQL_ReadResult(query, 0)
		SQL_FreeHandle(query)
		return temp
	}
#else
	switch(stype)
	{
		case 1:
		{
			new sip[32]
			get_user_ip(id, sip, charsmax(sip), 1)
			for(new i; i < datanum; i++)
			{
				if(equal(data[i][ip], sip) && data[i][type] == 1)
				{
					return i
				}
			}
		}
		case 2:
		{
			new ssteam[32]
			get_user_authid(id, ssteam, charsmax(ssteam))
			for(new i; i < datanum; i++)
			{
				if(equal(data[i][steam], ssteam) && data[i][type] == 2)
				{
					return i
				}
			}
		}
	}
#endif
	return -1
}
#if !defined MYSQL
stock get_pos_name(const sname[])
{
	for(new i; i < datanum; i++)
	{
		if(equal(data[i][name], sname))
		{
			return i
		}
	}
	return -1
}
#endif

stock is_black_list(id)
{
	new sip[32]
	get_user_ip(id, sip, charsmax(sip), 1)
	for(new i; i < blacknum; i++)
	{
		if(equal(sip, blacklist[i]))
		{
			return 1
		}
	}
	return 0
}

stock color_print(id, const input[], any:...)
{
	new msg[191]
	vformat(msg, 190, input, 3)
	format(msg, 190, "!y[!gName Locker!y] %s", msg)
	replace_all(msg, 190, "!g", "^4")
	replace_all(msg, 190, "!y", "^1")
	replace_all(msg, 190, "!t", "^3")
	msg[190] = '^0'
	if(id && is_user_connected(id))
	{
		message_begin(MSG_ONE_UNRELIABLE, sayt, _, id)
		write_byte(id)
		write_string(msg)
		message_end()
		return 1
	}
	else
	{
		for(new i = 1; i <= get_maxplayers(); i++)
		{
			if(!is_user_connected(i))
			{
				continue;
			}
			message_begin(MSG_ONE_UNRELIABLE, sayt, _, i)
			write_byte(i)
			write_string(msg)
			message_end()
		}
		return 1
	}
	return 0
}